diff --git a/cppsrc/U8x8lib.cpp b/cppsrc/U8x8lib.cpp
index 451968e7..381b0a8c 100644
--- a/cppsrc/U8x8lib.cpp
+++ b/cppsrc/U8x8lib.cpp
@@ -379,7 +379,8 @@ extern "C" uint8_t u8x8_byte_arduino_hw_spi(u8x8_t *u8x8, uint8_t msg, uint8_t a
 
 
       /* issue #377 */
-#if defined(ESP8266) || defined(ARDUINO_ARCH_ESP8266) || defined(ESP_PLATFORM) || defined(ARDUINO_ARCH_ESP32)
+      /* issue #378: removed ESP8266 support, which is implemented differently */
+#if defined(ESP_PLATFORM) || defined(ARDUINO_ARCH_ESP32)
       /* ESP32 has the following begin: SPI.begin(int8_t sck=SCK, int8_t miso=MISO, int8_t mosi=MOSI, int8_t ss=-1); */
       /* not sure about ESP8266 */
       if ( u8x8->pins[U8X8_PIN_I2C_CLOCK] != U8X8_PIN_NONE && u8x8->pins[U8X8_PIN_I2C_DATA] != U8X8_PIN_NONE )
diff --git a/csrc/u8x8_d_st75256.c b/csrc/u8x8_d_st75256.c
index fba9f768..ea9bd62a 100644
--- a/csrc/u8x8_d_st75256.c
+++ b/csrc/u8x8_d_st75256.c
@@ -38,6 +38,10 @@
   
   cad 011
   
+  
+  code examples:
+  http://www.it610.com/article/2601023.htm
+  
 */
 
 
@@ -625,16 +629,16 @@ static const uint8_t u8x8_d_st75256_jlx172104_init_seq[] = {
   U8X8_CA( 0x0d7, 0x09f ),		/* disable auto read */  
   U8X8_DLY(20),
   
-  U8X8_C( 0x031 ),				/* select 01 commands */
-  U8X8_CA( 0x0e0, 0x000 ),		/* enable OTP read */
+  //U8X8_C( 0x031 ),				/* select 01 commands */
+  //U8X8_CA( 0x0e0, 0x000 ),		/* enable OTP read */
   U8X8_DLY(20),
   
-  U8X8_C( 0x031 ),				/* select 01 commands */
-  U8X8_C( 0x0e3 ),				/* OTP Upload */
+  //U8X8_C( 0x031 ),				/* select 01 commands */
+  //U8X8_C( 0x0e3 ),				/* OTP Upload */
   U8X8_DLY(20),
   
-  U8X8_C( 0x031 ),				/* select 01 commands */
-  U8X8_C( 0x0e1 ),				/* OTP controll out */
+  //U8X8_C( 0x031 ),				/* select 01 commands */
+  //U8X8_C( 0x0e1 ),				/* OTP controll out */
   U8X8_DLY(20),
   
   U8X8_C( 0x030 ),				/* select 00 commands */
@@ -645,53 +649,94 @@ static const uint8_t u8x8_d_st75256_jlx172104_init_seq[] = {
   U8X8_C( 0xae ),				/* display off */
   U8X8_DLY(10),
   
-  U8X8_C( 0x030 ),				/* select 00 commands */
-  U8X8_CA( 0x020, 0x00b ),		/* Power control: Regulator, follower & booster on */
-  U8X8_DLY(10),
- 
-  U8X8_C( 0x030 ),				/* select 00 commands */
-  U8X8_CAA( 0x81, 0x36, 0x05 ),	/* Volume control */
+  U8X8_C( 0x031 ),				/* select 01 commands */
+  U8X8_C( 0x032 ),				/* analog circuit set */
+  U8X8_A( 0x000 ),				/* code example: OSC Frequency adjustment */
+  U8X8_A( 0x001 ),				/* Frequency on booster capacitors 1 = 6KHz? */
+  U8X8_A( 0x003 ),				/* Bias: 1: 1/13, 2: 1/12, 3: 1/11, 4:1/10, 5:1/9 */
   
   U8X8_C( 0x031 ),				/* select 01 commands */
   U8X8_C( 0x020 ),				/* gray levels */
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x17 ),
-  U8X8_A( 0x17),
+  U8X8_A( 0x01 ),
+  U8X8_A( 0x03 ),
+  U8X8_A( 0x05 ),
+  U8X8_A( 0x07 ),
+  U8X8_A( 0x09),
+  U8X8_A( 0x0b ),
+  U8X8_A( 0x0d ),
+  U8X8_A( 0x10 ),
+  U8X8_A( 0x11 ),
+  U8X8_A( 0x13 ),
+  U8X8_A( 0x15 ),
   U8X8_A( 0x17 ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x1d ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x1d ),
+  U8X8_A( 0x19 ),
+  U8X8_A( 0x1b ),
   U8X8_A( 0x1d ),
+  U8X8_A( 0x1f ),
+ 
+ U8X8_C( 0x031 ),				/* select 01 commands */
+  U8X8_C( 0x021 ),				/* gray levels */
+  U8X8_A( 0x01 ),
+  U8X8_A( 0x03 ),
+  U8X8_A( 0x05 ),
+  U8X8_A( 0x07 ),
+  U8X8_A( 0x09),
+  U8X8_A( 0x0b ),
+  U8X8_A( 0x0d ),
+  U8X8_A( 0x10 ),
+  U8X8_A( 0x11 ),
+  U8X8_A( 0x13 ),
+  U8X8_A( 0x15 ),
+  U8X8_A( 0x17 ),
+  U8X8_A( 0x19 ),
+  U8X8_A( 0x1b ),
   U8X8_A( 0x1d ),
-  U8X8_A( 0x00 ),
-  U8X8_A( 0x00 ),
+  U8X8_A( 0x1f ),
   
-  U8X8_C( 0x031 ),				/* select 01 commands */
-  U8X8_C( 0x032 ),				/* analog circuit set */
-  U8X8_A( 0x000 ),				/* code example: OSC Frequency adjustment */
-  U8X8_A( 0x001 ),				/* Frequency on booster capacitors 1 = 6KHz? */
-  U8X8_A( 0x000 ),				/* Bias: 1: 1/13, 2: 1/12, 3: 1/11, 4:1/10, 5:1/9 */
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CAA(0x75, 0, 0x4f),		/* row range */
+  U8X8_CAA(0x15, 0, 255),		/* col range */
   
-  U8X8_C( 0x031 ),				/* select 01 commands */
-  U8X8_CA( 0x051, 0x0fb ),		/* booster level x10 */
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CA( 0xbc, 0x02 ),			/* data scan dir */
+  U8X8_A( 0x01 ),				/* ??? */
+  U8X8_A( 0x02 ),				/* ??? */
 
-  U8X8_C( 0x030 ),				/* select 00 commands */ 
-  U8X8_CA( 0x0f0, 0x011 ),		/* monochrome mode  = 0x010*/
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CA( 0x007, 0x019 ),		/* ???*/
+
+  U8X8_C( 0x031 ),				/* select 00 commands */
+  U8X8_CA( 0x0cd, 0x000 ),				/* ??? */
+  U8X8_DLY(60),
+  U8X8_C( 0x0fd ),				/* ??? */
+  U8X8_DLY(60),
+  U8X8_C( 0x0cc ),				/* ??? */
+  U8X8_C( 0x014 ),				/* dithering off??? */
+
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_C( 0x00c ),				/* ??? */
 
   U8X8_C( 0x030 ),				/* select 00 commands */ 
   U8X8_C( 0xca ),				/* display control, 3 args follow  */
-  U8X8_A( 0x00 ),				/* no clock division */
-  U8X8_A( 0x7f ),				/* 1/128 duty value from the DS overview page*/
-  //U8X8_A( 0x9f ),				/* 1/160 duty value from the DS example code */
-  U8X8_A( 0x00 ),				/* nline off */ 
+  U8X8_A( 0x00 ),				/* 0x00: no clock division, 0x04: devide clock */
+  //U8X8_A( 0x7f ),				/* 1/128 duty value from the DS overview page*/
+  U8X8_A( 0x9f ),				/* 1/160 duty value from the DS example code */
+  U8X8_A( 0x20 ),				/* nline off */ 
+
+  U8X8_C( 0x030 ),				/* select 00 commands */ 
+  U8X8_CA( 0x0f0, 0x011 ),		/* monochrome mode  = 0x010*/
 
   U8X8_C( 0x030 ),				/* select 00 commands */
-  U8X8_CA( 0xbc, 0x00 ),			/* data scan dir */
+  U8X8_CAA( 0x81, 0x08, 0x04 ),	/* Volume control */
+  
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CA( 0x020, 0x00b ),		/* Power control: Regulator, follower & booster on */
+  U8X8_DLY(10),
+ 
+
+  //U8X8_C( 0x031 ),				/* select 01 commands */
+  //U8X8_CA( 0x051, 0x0fb ),		/* booster level x10 */
+
 
   U8X8_C( 0x031 ),				/* select 01 commands */
   U8X8_C( 0x040 ),				/* internal power */
@@ -702,8 +747,9 @@ static const uint8_t u8x8_d_st75256_jlx172104_init_seq[] = {
   U8X8_C( 0xaf ),				/* display on  */
 
   U8X8_C( 0x030 ),				/* select 00 commands */
-  U8X8_CAA(0x75, 0, 16),		/* row range */
-  U8X8_CAA(0x15, 0, 255),		/* col range */
+  U8X8_CAA(0x75, 6, 0x4f),		/* row range */
+  U8X8_CAA(0x15, 83, 255),		/* col range */
+
   U8X8_C( 0x030 ),				/* select 00 commands */
   U8X8_C( 0x5c ),				/* write data to RAM  */
   U8X8_A( 0xff ),				/*  */
@@ -715,6 +761,15 @@ static const uint8_t u8x8_d_st75256_jlx172104_init_seq[] = {
   U8X8_A( 0xff ),				/*  */
   U8X8_A( 0xff ),				/*  */
 
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+  U8X8_A( 0x0 ),				/*  */
+
   U8X8_A( 0xff ),				/*  */
   U8X8_A( 0xff ),				/*  */
   U8X8_A( 0xff ),				/*  */
@@ -756,6 +811,51 @@ static const uint8_t u8x8_d_st75256_jlx172104_init_seq[] = {
 };    
 
 
+static const uint8_t u8x8_d_st75256_jlx172104_init_seq_m[] = {
+  U8X8_START_TRANSFER(),             	/* enable chip, delay is part of the transfer start */
+  
+  U8X8_DLY(120),
+
+  
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_C( 0x094 ),				/* sleep out */
+  U8X8_DLY(10),
+
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_C( 0xa6 ),				/* normal display  */
+  U8X8_C( 0x22 ),				/* all pixel off mode  */
+  U8X8_C( 0xaf ),				/* display on  */
+
+
+  U8X8_C( 0x031 ),				/* select 01 commands */
+  U8X8_C( 0x032 ),				/* analog circuit set */
+  U8X8_A( 0x000 ),				/* code example: OSC Frequency adjustment */
+  U8X8_A( 0x000 ),				/* 0..3 Frequency on booster capacitors 1 = 6KHz? */
+  U8X8_A( 0x003 ),				/* Bias: 1: 1/13, 2: 1/12, 3: 1/11, 4:1/10, 5:1/9 */
+
+  U8X8_C( 0x030 ),				/* select 00 commands */ 
+  U8X8_C( 0xca ),				/* display control, 3 args follow  */
+  U8X8_A( 0x00 ),				/* 0x00: no clock division, 0x04: devide clock */
+  //U8X8_A( 0x7f ),				/* 1/128 duty value from the DS overview page*/
+  U8X8_A( 0x9f ),				/* 1/160 duty value from the DS example code */
+  U8X8_A( 0x00 ),				/* nline off */ 
+
+  U8X8_C( 0x030 ),				/* select 00 commands */ 
+  U8X8_CA( 0x0f0, 0x011 ),		/* monochrome mode  = 0x010*/
+
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CAA( 0x81, 0x08, 0x04 ),	/* Volume control: 00-3f 0..7 */
+  
+  U8X8_C( 0x030 ),				/* select 00 commands */
+  U8X8_CA( 0x020, 0x00b ),		/* Power control: Regulator, follower & booster on */
+  U8X8_DLY(10),
+
+
+  U8X8_END_TRANSFER(),             	/* disable chip */
+  U8X8_END()             			/* end of sequence */
+};    
+
+
 uint8_t u8x8_d_st75256_jlx172104(u8x8_t *u8x8, uint8_t msg, uint8_t arg_int, void *arg_ptr)
 {
   if ( u8x8_d_st75256_256x128_generic(u8x8, msg, arg_int, arg_ptr) != 0 )
@@ -769,7 +869,7 @@ uint8_t u8x8_d_st75256_jlx172104(u8x8_t *u8x8, uint8_t msg, uint8_t arg_int, voi
   else if ( msg == U8X8_MSG_DISPLAY_INIT )
   {
     u8x8_d_helper_display_init(u8x8);
-    u8x8_cad_SendSequence(u8x8, u8x8_d_st75256_jlx172104_init_seq);    
+    u8x8_cad_SendSequence(u8x8, u8x8_d_st75256_jlx172104_init_seq_m);
     
     for(;;)
       ;
diff --git a/sys/arduino/u8g2_page_buffer/HelloWorld/HelloWorld.ino b/sys/arduino/u8g2_page_buffer/HelloWorld/HelloWorld.ino
index 30585a7c..5263caa4 100644
--- a/sys/arduino/u8g2_page_buffer/HelloWorld/HelloWorld.ino
+++ b/sys/arduino/u8g2_page_buffer/HelloWorld/HelloWorld.ino
@@ -171,7 +171,8 @@
 
 // End of constructor list
 
-U8G2_ST75256_JLX172104_1_4W_SW_SPI u8g2(U8G2_R0, /* clock=*/ 13, /* data=*/ 11, /* cs=*/ 10, /* dc=*/ 9, /* reset=*/ 8);
+//U8G2_ST75256_JLX172104_1_4W_HW_SPI u8g2(U8G2_R0, /* clock=*/ 13, /* data=*/ 11, /* cs=*/ 10, /* dc=*/ 9, /* reset=*/ 8);
+U8G2_ST75256_JLX172104_1_4W_HW_SPI u8g2(U8G2_R0, /* cs=*/ 10, /* dc=*/ 9, /* reset=*/ 8);
 
 void setup(void) {
 
